-- リスト4: bitshiftをシミュレーションするためのテスト・ベンチ(VHDL)

library IEEE; -- おまじない

use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use IEEE.std_logic_arith.all;

entity bitshift_sim is -- テスト・ベンチなので入出力はない
  generic (
    width : integer := 4
    );
end bitshift_sim;

architecture rtl of bitshift_sim is

  component bitshift -- bitshiftをサブ・モジュールとして呼び出すための宣言
    generic (
      width : integer := 4
      );
    port (
      pClk   : in std_logic;
      Q      : out std_logic_vector(width-1 downto 0);
      pReset : in std_logic);
  end component;

  signal cQ     : std_logic_vector(width-1 downto 0);
  signal cClk   : std_logic;
  signal cReset : std_logic;

begin  -- rtl

  U: bitshift
    generic map(width => width)
    port map(
      pClk   => cClk,
      Q      => cQ,
      pReset => cReset
      );

  process
  begin
    cReset <= '0';
    cClk <= '1'; wait for 10ns;
    cClk <= '0'; wait for 10ns;
    cClk <= '1'; wait for 10ns;
    cClk <= '0'; wait for 10ns;
    cReset <= '1';
    cClk <= '1'; wait for 10ns;
    cClk <= '0'; wait for 10ns;
    cReset <= '0';
    cClk <= '1'; wait for 10ns;
    cClk <= '0'; wait for 10ns;
    loop
      cClk <= '1'; wait for 10ns;
      cClk <= '0'; wait for 10ns;
    end loop;
  end process;

end rtl;
