-- rs232c_txをシミュレーションするためのテスト・ベンチ
library ieee;
use ieee.std_logic_1164.ALL;
use ieee.std_logic_arith.ALL;
use ieee.std_logic_unsigned.ALL;

entity rs232c_tx_sim is
end rs232c_tx_sim;

architecture RTL of rs232c_tx_sim is

  component rs232c_tx
    generic (
      sys_clk : integer := 14000000;
      rate : integer := 9600
      );
    port (
      clk   : in  std_logic;
      rst   : in  std_logic;
      wr    : in  std_logic;
      din   : in  std_logic_vector(7 downto 0);
      dout  : out std_logic;
      ready : out std_logic
      );
  end component;
  
  signal clk, rst, wr : std_logic;
  signal din   : std_logic_vector(7 downto 0);
  signal dout, ready  : std_logic;

  signal data : std_logic_vector(7 downto 0);

begin
  
  U : rs232c_tx port map (clk, rst, wr, din, dout, ready);

  process
  begin
      clk <= '0'; wait for 10ns;
      rst <= '1';
      clk <= '1'; wait for 10ns;
      clk <= '0'; wait for 10ns;
      clk <= '1'; wait for 10ns;
      rst <= '0';
      clk <= '0'; wait for 10ns;
      clk <= '1'; wait for 10ns;
    loop
      clk <= '0'; wait for 10ns;
      clk <= '1'; wait for 10ns;
    end loop;
  end process;

  process(rst, ready)
  begin
    if rst = '1' then
      data <= X"30";
      wr <= '0';
    elsif ready = '1' then
      wr <= '1';
      din <= data;
      data <= data + 1;
    else
      wr <= '0';
      din <= (others => 'Z');
    end if;
  end process;

end RTL;
